#ifndef LBXIMG_H_
#define LBXIMG_H_

#include <stdio.h>

struct lbx_file_ops;

struct lbx_image {
	unsigned short width, height;
	unsigned char frames, chunk;
};

struct lbx_colour {
	unsigned red:6, green:6, blue:6, active:1;
};

struct lbx_imginfo {
	unsigned char loopstart;
	int palettesz, looping;
};

struct lbx_image *lbx_img_open(void *f, const struct lbx_file_ops *fops,
                               int (*destructor)(void *));
struct lbx_image *lbx_img_fopen(const char *file);
int     lbx_img_close(struct lbx_image *img);

unsigned char **lbx_img_getframe(struct lbx_image *img, int frame);
unsigned char **lbx_img_getmask(struct lbx_image *img);

int lbx_img_loadpalette(void *f, const struct lbx_file_ops *fops,
                       struct lbx_colour palette[static 256]);
int lbx_img_getpalette(struct lbx_image *img,
                       struct lbx_colour palette[static 256]);

void lbx_img_getinfo(struct lbx_image *img, struct lbx_imginfo *info);

#endif
